import pickle

from enum import Enum


class SipMissingMembers:

    @classmethod
    def _missing_(cls, cpp):
        try:
            return cls._sip_missing[cpp]
        except KeyError:
            pass
        except AttributeError:
            cls._sip_missing = {}

        member = object.__new__(cls)
        member._name_ = str(cpp)
        member._value_ = cpp

        cls._sip_missing[cpp] = member

        return member


class SomePyQtEnum(SipMissingMembers, Enum):

    one = 1
    two = 2


def cpp2py(etype, cpp):
    return etype(cpp)


def py2cpp(py):
    return py.value


e1 = cpp2py(SomePyQtEnum, 1)
e2 = cpp2py(SomePyQtEnum, 2)
e3minus = cpp2py(SomePyQtEnum, -3)
e4 = cpp2py(SomePyQtEnum, 4)
e4a = cpp2py(SomePyQtEnum, 4)

print(e1)
print(e2)
print(e3minus)
print(e4)
print(e4a)
print(e4 is e4a)

print(py2cpp(e1))
print(py2cpp(e2))
print(py2cpp(e3minus))
print(py2cpp(e4))


dump = pickle.dumps(cpp2py(SomePyQtEnum, 4))
print(pickle.loads(dump))

# Try loading a value that has not been passed through cpp2py first.
# Generated via print(pickle.dumps(SomePyQtEnum(5)))
print(pickle.loads(b'\x80\x04\x95#\x00\x00\x00\x00\x00\x00\x00\x8c\x08__main__\x94\x8c\x0cSomePyQtEnum\x94\x93\x94K\x05\x85\x94R\x94.'))
